// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2022, Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


using System;
using Hiperscan.ApoIdentCore.SectionManager.FieldDefinitions;
using Hiperscan.Unix;

namespace Hiperscan.ApoIdentCore.SectionManager.Result.Fields
{
    public class AdditionalTestField : InputField<string>
    {
        public AdditionalTestField()
        {
            this.Init();
        }

        public override void SetDefaultValue()
        {
            this.Entry = String.Empty;
        }

        protected override bool CheckEntry()
        {
            if (this.is_mandatory == false)
                return true;

            return String.IsNullOrEmpty((this.entry ?? String.Empty).Trim()) == false;
        }

        protected override bool Compare(string value1, string value2)
        {
            return value1 == value2;
        }

        public override string GetEntryValue()
        {
            return this.entry;
        }

        private bool is_mandatory = false;
        public bool IsMandatory
        {
            get
            {
                return this.is_mandatory;
            }

            set
            {
                if (this.is_mandatory == value)
                    return;

                this.is_mandatory = value;

                bool tmp = this.CheckEntry();
                bool fire_state_event = (tmp != this.IsEntryValid);
                this.IsEntryValid = tmp;

                if (fire_state_event)
                    this.CallValidStateChangedEvent();
            }
        }

        public override string ErrorMessage => Catalog.GetString("This input field is mandatory.");
        public override int FieldLength => -1;
    }
}
